#ifndef __CODA_VECT__
#define __CODA_VECT__

#include "CodaBase.h"
#include <list>

using namespace std;

template <class Elem> 
class CodaList : public CodaBase<Elem> {
 private:
        list<Elem>  dati;
 public:
        CodaList(){};
        virtual ~CodaList(){};
        virtual bool enqueue(Elem e);
        virtual bool dequeue();
        virtual bool head(Elem &e);
        bool isempty();
};

template <class Elem> 
bool CodaList<Elem>::enqueue(Elem e)
{     
     dati.push_back(e);
     return true;
};

template <class Elem> 
bool CodaList<Elem>::dequeue() {
      
      
     if (dati.empty())
        return false;
     else
     {
        dati.pop_front();
        return true;
     }
};

template <class Elem> 
bool CodaList<Elem>::head(Elem &e)
{
     if (!dati.empty())
     {
        e = dati.front(); 
        return true;
     } 
     else 
         return false;
};

template <class Elem> 
bool CodaList<Elem>::isempty() 
{
    return dati.empty();
};      

#endif
