#ifndef __CODA_LIST_PRIOR__
#define __CODA_LIST_PRIOR__

#include "CodaBasePriorita.h"
#include <list>

using namespace std;

template <class Elem> 
class CodaListPrior : public CodaBasePriorita<Elem> {
 private:
        list<Elem>  dati;
        list<int>  prior;
 public:
        CodaListPrior(){};
        virtual ~CodaListPrior(){};
        virtual bool enqueue(Elem e, int p);
        virtual bool dequeue();
        virtual bool head(Elem &e);
        bool isempty();
};

template <class Elem> 
bool CodaListPrior<Elem>::enqueue(Elem e, int p)
{    
     typename list<Elem>::iterator i = dati.begin(); 
     list<int>::iterator j = prior.begin();
     while (i!=dati.end() && p>=*j)
     {
           i++;
           j++;
     }
     dati.insert(i,e);
     prior.insert(j,p);
     return true;
};

template <class Elem> 
bool CodaListPrior<Elem>::dequeue() {
      
      
     if (dati.empty())
        return false;
     else
     {
        dati.pop_front();
        prior.pop_front();
        return true;
     }
};

template <class Elem> 
bool CodaListPrior<Elem>::head(Elem &e)
{
     if (!dati.empty())
     {
        e = dati.front(); 
        return true;
     } 
     else 
         return false;
};

template <class Elem> 
bool CodaListPrior<Elem>::isempty() 
{
    return dati.empty();
};      

#endif
